package com.zcloud.basic.info.persistence.repository.impl;

import com.alibaba.cola.dto.PageResponse;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.jjb.saas.framework.repository.common.PageHelper;
import com.jjb.saas.framework.repository.repo.impl.BaseRepositoryImpl;
import com.zcloud.basic.info.domain.enums.UserEmploymentFlagEnum;
import com.zcloud.basic.info.persistence.dataobject.UserCorpRecordDO;
import com.zcloud.basic.info.persistence.mapper.UserCorpRecordMapper;
import com.zcloud.basic.info.persistence.repository.UserCorpRecordRepository;
import com.zcloud.gbscommon.utils.PageQueryHelper;
import com.zcloud.gbscommon.utils.Query;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * web-infrastructure
 *
 * @Author zhaokai
 * @Date 2025-12-03 10:21:59
 */
@Service
@RequiredArgsConstructor
public class UserCorpRecordRepositoryImpl extends BaseRepositoryImpl<UserCorpRecordMapper, UserCorpRecordDO> implements UserCorpRecordRepository {
    private final UserCorpRecordMapper userCorpRecordMapper;

    @Override
    public PageResponse<UserCorpRecordDO> listPage(Map<String, Object> params) {
        IPage<UserCorpRecordDO> iPage = new Query<UserCorpRecordDO>().getPage(params);
        QueryWrapper<UserCorpRecordDO> queryWrapper = new QueryWrapper<>();
        queryWrapper = PageQueryHelper.createPageQueryWrapper(queryWrapper, params);
        queryWrapper.orderByDesc("create_time");
        IPage<UserCorpRecordDO> result = userCorpRecordMapper.selectPage(iPage, queryWrapper);
        return PageHelper.pageToResponse(result, result.getRecords());
    }

    @Override
    public UserCorpRecordDO getInfoByUserId(Long id, Long corpinfoId, Integer code) {
        QueryWrapper<UserCorpRecordDO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("user_id", id);
        queryWrapper.eq("corpinfo_id", corpinfoId);
        queryWrapper.eq("employment_flag", code);
        return userCorpRecordMapper.selectOne(queryWrapper);
    }

    @Override
    public UserCorpRecordDO getInfoByUserStatus(Long id, Long corpinfoId, Integer status) {
        QueryWrapper<UserCorpRecordDO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("user_id", id);
        queryWrapper.eq("corpinfo_id", corpinfoId);
        queryWrapper.eq("status", status);
        return userCorpRecordMapper.selectOne(queryWrapper);
    }

    //获取用户下未离职的企业
    @Override
    public List<UserCorpRecordDO> getInfoListByUserId(Long id) {
        QueryWrapper<UserCorpRecordDO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("user_id", id);
        queryWrapper.ne("employment_flag", UserEmploymentFlagEnum.RESIGNATION.getCode());
        return userCorpRecordMapper.selectList(queryWrapper);
    }

    @Override
    public UserCorpRecordDO getUserCorpRecordInfoByUserStatus(Long userId, Long corpinfoId, Integer status) {
        return userCorpRecordMapper.getUserCorpRecordInfoByUserStatus(userId,corpinfoId,status);
    }
}

